DEV Community

Wenqi Jiang
Wenqi Jiang

Posted on

778. Swim in Rising Water

778. Swim in Rising Water

Description

You are given an n x n integer matrix grid where each value grid[i][j] represents the elevation at that point (i, j).

The rain starts to fall. At time t, the depth of the water everywhere is t. You can swim from a square to another 4-directionally adjacent square if and only if the elevation of both squares individually are at most t. You can swim infinite distances in zero time. Of course, you must stay within the boundaries of the grid during your swim.

Return the least time until you can reach the bottom right square (n - 1, n - 1) if you start at the top left square (0, 0).

Example 1:

Untitled

Input: grid = [[0,2],[1,3]]
Output: 3
Explanation:
At time 0, you are in grid location (0, 0).
You cannot go anywhere else because 4-directionally adjacent neighbors have a higher elevation than t = 0.
You cannot reach point (1, 1) until time 3.
When the depth of water is 3, we can swim anywhere inside the grid.
Enter fullscreen mode Exit fullscreen mode

Example 2:

Untitled

Input: grid = [[0,1,2,3,4],[24,23,22,21,5],[12,13,14,15,16],[11,17,18,19,20],[10,9,8,7,6]]
Output: 16
Explanation: The final route is shown.
We need to wait until time 16 so that (0, 0) and (4, 4) are connected.
Enter fullscreen mode Exit fullscreen mode

Constraints:

  • n == grid.length
  • n == grid[i].length
  • 1 <= n <= 50
  • 0 <= grid[i][j] < n2
  • Each value grid[i][j] is unique.

Solutions

Solution 1

Intuition

  1. binary search
  2. dfs to check if go from top left to bottom right?

Code

class Solution {
public:
    int dx[4] = {0, 1, 0, -1}, dy[4] = {1, 0, -1, 0};
    int n;
    vector<vector<int>> g;
    vector<vector<bool>> visited;

    bool dfs(int x, int y, int elevation) {
        if (x == n - 1 && y == n - 1) return true;
        visited[x][y] = true;
        for (int k = 0; k < 4; k++) {
            int i = x + dx[k], j = y + dy[k];
            if (i >= 0 && i < n && j >= 0 && j < n && g[i][j] <= elevation && !visited[i][j] && dfs(i, j, elevation))
                return true;
        }
        return false;
    }

    bool check(int elevation) {
        if (g[0][0] > elevation) return false;
        visited = vector<vector<bool>>(n, vector<bool>(n, false));
        return dfs(0, 0, elevation);
    }

    int swimInWater(vector<vector<int>>& grid) {
        g = grid;
        n = grid.size();
        int l = 0, r = n * n;
        while (l < r) {
            int mid = l + r >> 1;
            if (check(mid))
                r = mid;
            else
                l = mid + 1;
        }
        return l;
    }
};
Enter fullscreen mode Exit fullscreen mode

Complexity

  • Time: O(nlogn)
  • Space: O(n)

Solution 2

Intuition

Code


Enter fullscreen mode Exit fullscreen mode

Complexity

  • Time:
  • Space:

Similar Questions

Top comments (0)